unit hiLPTnew;

interface

uses Kol,Share,Windows,Debug;

///         DLL ////////////////////////////
  function Out32(PortAdrOut: word; Data: byte): byte; stdcall; external 'inpout32.dll';//
  function Inp32(PortAdrOut: word): byte; stdcall; external 'inpout32.dll';            //
//////////////////////////////////////////////////////////////////////////////////////
type //   
 THILPTNEW = class(TDebug)
private                            //     ,       
   PortAdr:word;                   //    (888,632,956)
   PortDataRead:byte;              //      
   PortDataWrite:byte;             //      
public   //   //              //     InlineCode
    _event_onBUSY:THI_Event;       //   SR7
	_event_onACK:THI_Event;        //   SR6  
	_event_onPE:THI_Event;         //   SR5
	_event_onSEL:THI_Event;        //   SR4
	_event_onERR:THI_Event;        //   SR3
	_event_onIRQ:THI_Event;        //   SR2
	_event_onAllDataOut:THI_Event; //       
    _event_onDataOut:THI_Event;    //       Port+0 
    _event_onStatus:THI_Event;     //       Port+1 
    _event_onControl:THI_Event;    //      Port+2  
	_event_onDataOutDual:THI_Event; //        SPP  EPP
	_data_DataPort0:THI_Event;     //      ( )
    _data_DataPort2:THI_Event;     //      (control)
//////    ////////////////////// 
//////     Port0 /////////////////////////////
      procedure _work_doReadData(var _Data:TData; Index:word);
//////     Port0 SPP  EPP  ///////////////////
      procedure _work_doReadDataDual(var _Data:TData; Index:word);
//////     Port0 /////////////////////////////	  
	  procedure _work_doWriteData(var _Data:TData; Index:word); 
//////     Port0 /////////////////////////////	  
	 procedure  SetBit0(var _Data:TData; X:byte);          //
	 procedure _work_doD0(var _Data:TData; Index:word);    //
	 procedure _work_doD1(var _Data:TData; Index:word);    //
	 procedure _work_doD2(var _Data:TData; Index:word);    //
	 procedure _work_doD3(var _Data:TData; Index:word);    //
	 procedure _work_doD4(var _Data:TData; Index:word);    //
	 procedure _work_doD5(var _Data:TData; Index:word);    //
	 procedure _work_doD6(var _Data:TData; Index:word);    //
	 procedure _work_doD7(var _Data:TData; Index:word);    //
//////     Port2 /////////////////////////////	  
	 procedure  SetBit2(var _Data:TData; X:byte);          //
	 procedure _work_doDIR(var _Data:TData; Index:word);   //
	 procedure _work_doIntEn(var _Data:TData; Index:word); //
	 procedure _work_doSelIn(var _Data:TData; Index:word); //
	 procedure _work_doINIT(var _Data:TData; Index:word);  //
	 procedure _work_doAF(var _Data:TData; Index:word);    //
	 procedure _work_doSTRB(var _Data:TData; Index:word);  //
///////////////////////////////////////////////////////////////	 
	 procedure _work_doReadStatus(var _Data:TData; Index:word);   //    
     procedure _work_doWriteControl(var _Data:TData; Index:word); //    
/////     /////////////////	  
	 procedure _var_Port0(var _Data:TData; Index:word);	    //  Port0 (     _var_Port0)
     procedure _var_Port1(var _Data:TData; Index:word);     //  Port1 (     _var_Port1)
     procedure _var_Port2(var _Data:TData; Index:word);     //  Port2 (     _var_Port2)
     property _prop_Port:word write PortAdr;
 
 end;
 ////   //////////////////////////////////////
implementation                                         //
/////////////////////////////////////////////////////////
////      (Port0)            //
///////////////////////////////////////////////////////// 
procedure THILPTNEW._work_doReadData;                  //     Port+0 (  Data)
begin                                                  //
  PortDataRead := Inp32(PortAdr);                      //     ( Inp32()  inpout32.dll)     PortDataRead
  _hi_OnEvent(_event_onDataOut,PortDataRead);          //           
  _hi_OnEvent(_event_onAllDataOut,PortDataRead);       //          
end;                                                   //
/////////////////////////////////////////////////////////
//// Dual      (Port0)        //
///////////////////////////////////////////////////////// 
procedure THILPTNEW._work_doReadDataDual;               //     Port+0 ( )
var                                                    //
  OldCR,DR,CR,SR:byte;                                       //    
begin                                                  //
  SR := Inp32(PortAdr+1); //   
  if (SR and (1 shl 7) <> 0) then //   BUSY  1 (..=0)  
                                begin
                                   PortDataRead := Inp32(PortAdr); //     
                                   OldCR := Inp32(PortAdr+2); //        
                                   CR := OldCR ;
                                   CR := CR or (1 shl 5); //   STRB 
                                   CR := CR or (1 shl 0); //    
								   Out32(PortAdr+2,CR);   //   ,       
                                   //MessageBox(0,'    ','!!!',MB_OK+MB_ICONERROR); //   BUSY       
                                   
                                   DR := Inp32(PortAdr); //     
                                   
                                   Out32(PortAdr+2,OldCR);   //   ,       
                                   
                                   Out32(PortAdr,PortDataRead);///  );///  
                                   _hi_OnEvent(_event_onDataOutDual,DR);   //          
                                   _hi_OnEvent(_event_onAllDataOut,DR);//       
                                   
                                end 
                              else
                               begin
MessageBox(0,'    ','!!!',MB_OK+MB_ICONERROR); //   BUSY       
                               end;                     
  end;
/////////////////////////////////////////////////////////
////      (Port0)              //
/////////////////////////////////////////////////////////
procedure THILPTNEW._work_doWriteData;                 //     Port+0
begin                                                  //
  PortDataWrite := ReadInteger(_Data,_data_DataPort0); //        DataPort0    PortDataWrite
  Out32(PortAdr,PortDataWrite);                        //      Out32()  DLL (PortAdr= ) 
  _hi_OnEvent(_event_onDataOut,PortDataWrite);         //           
  _hi_OnEvent(_event_onAllDataOut,PortDataWrite);      //          
end;                                                   //
/////////////////////////////////////////////////////////
////      (Port0)            //
/////////////////////////////////////////////////////////
procedure THILPTNEW.SetBit0;                           //       
begin                                                  //
   PortDataWrite := PortDataWrite or X;                //   1   1
// OR - ()  ,    
// A	B	Y
// 0	0	0
// 0	1	1
// 1	0	1
// 1	1	1
   if not ReadBool(_Data) then                         // not =     1 () 
   PortDataWrite := PortDataWrite xor X;               // ( )        0
//XOR - ()  ,    
// A	B	Y
// 0	0	0
// 0	1	1
// 1	0	1
// 1	1	0
   Out32(PortAdr,PortDataWrite);                     //   
   PortDataRead := Inp32(PortAdr);                   //      
  _hi_OnEvent(_event_onDataOut,PortDataRead);        //           
  _hi_OnEvent(_event_onAllDataOut,PortDataRead);     //          
end;                                                 //
procedure THILPTNEW._work_doD0;                      //
begin  SetBit0(_Data,$01);end;// $01 = 00000001      // 0x01h     =  X
procedure THILPTNEW._work_doD1;                      // 
begin  SetBit0(_Data,$02);end;// $02 = 00000010      //
procedure THILPTNEW._work_doD2;                      //
begin  SetBit0(_Data,$04);end;// $04 = 00000100      //
procedure THILPTNEW._work_doD3;                      //
begin  SetBit0(_Data,$08);end;// $08 = 00001000      //
procedure THILPTNEW._work_doD4;                      //
begin  SetBit0(_Data,$10);end;// $10 = 00010000      //
procedure THILPTNEW._work_doD5;                      //
begin  SetBit0(_Data,$20);end;// $20 = 00100000      //
procedure THILPTNEW._work_doD6;                      //
begin  SetBit0(_Data,$40);end;// $40 = 01000000      //
procedure THILPTNEW._work_doD7;                      //
begin  SetBit0(_Data,$80);end;// $80 = 10000000      //
///////////////////////////////////////////////////////
//   Port1 ( ) ////////////////
/////////////////////////////////////////////////////// 
procedure THILPTNEW._work_doReadStatus; //      Port+1
var 
w:integer;
begin
    w := PortDataRead;
    PortDataRead := Inp32(PortAdr+1);
    w := (PortDataRead xor w)*$100 + PortDataRead;// $100 = 100000000
    w := w shr 3; if (w and $100)<>0 then _hi_onEvent(_event_onERR, w and $01); //    (if Value and (1 shl N) <> 0 then ... )
    w := w shr 1; if (w and $100)<>0 then _hi_onEvent(_event_onSEL,w and $01);  //                       (if Value and (1 shl N) = 0 then ...  )
    w := w shr 1; if (w and $100)<>0 then _hi_onEvent(_event_onPE,  w and $01); //
    w := w shr 1; if (w and $100)<>0 then _hi_onEvent(_event_onACK, w and $01); // 
    w := w shr 1; if (w and $100)<>0 then _hi_onEvent(_event_onBUSY,w and $01);
    _hi_OnEvent(_event_onStatus,PortDataRead);           //           
    _hi_OnEvent(_event_onAllDataOut,PortDataRead);       //          
end;                                                     //
///////////////////////////////////////////////////////////
//      (Port2)               //
/////////////////////////////////////////////////////////// 
procedure THILPTNEW._work_doWriteControl;                //    Port+2 ( D4 )
begin                                                    //
    PortDataWrite := ReadInteger(_Data,_data_DataPort2); //          
	Out32(PortAdr+2,PortDataWrite);                      //      Out32()  DLL (PortAdr= : dat=     ) 
    _hi_OnEvent(_event_onControl,PortDataWrite);         //           
    _hi_OnEvent(_event_onAllDataOut,PortDataWrite);      //          
end;                                                     //
///////////////////////////////////////////////////////////
////      (Port2)       //////
///////////////////////////////////////////////////////////
procedure THILPTNEW.SetBit2;                             //       
begin                                                    //
   PortDataWrite := PortDataWrite or X;                  // (  )   1   1
    if not ReadBool(_Data) then                          // (not = )    1 () 
   PortDataWrite := PortDataWrite xor X;                 // (  )        0
   Out32(PortAdr+2,PortDataWrite);                       //   2
  _hi_OnEvent(_event_onControl,PortDataWrite);           //    
  _hi_OnEvent(_event_onAllDataOut,PortDataWrite);        //          
end;
////      //
procedure THILPTNEW._work_doSTRB;
begin  SetBit2(_Data,$01); end;//    (  )
procedure THILPTNEW._work_doAF;
begin  SetBit2(_Data,$02); end;// $02 = 00000010
procedure THILPTNEW._work_doINIT;
begin  SetBit2(_Data,$04); end;
procedure THILPTNEW._work_doSelIn;
begin  SetBit2(_Data,$08); end;
procedure THILPTNEW._work_doIntEn;
begin  SetBit2(_Data,$10); end;
procedure THILPTNEW._work_doDIR;
begin  SetBit2(_Data,$20); end;
////////////////////////////////////////////////
//    //////////////// 
procedure THILPTNEW._var_Port0;               //
begin dtInteger(_Data,Inp32(PortAdr));end;    //    
procedure THILPTNEW._var_Port1;               //
begin dtInteger(_Data,Inp32(PortAdr+1));end;  //
procedure THILPTNEW._var_Port2;               //
begin dtInteger(_Data,Inp32(PortAdr+2));end;  //
////////////////////////////////////////////////
end.
